<template>
  <ContentWrap>
    <!-- 搜索工作栏 -->
    <el-form
      class="-mb-15px"
      :model="queryParams"
      ref="queryFormRef"
      :inline="true"
      label-width="68px"
    >
      <el-form-item label="问卷名称" prop="bqQuestionnaire">
        <el-input
          v-model="queryParams.bqQuestionnaire"
          placeholder="请输入问卷名称"
          clearable
          @keyup.enter="handleQuery"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item label="创建时间" prop="createTime">
        <el-date-picker
          v-model="queryParams.createTime"
          value-format="YYYY-MM-DD HH:mm:ss"
          type="daterange"
          start-placeholder="开始日期"
          end-placeholder="结束日期"
          :default-time="[new Date('1 00:00:00'), new Date('1 23:59:59')]"
          class="!w-220px"
        />
      </el-form-item>
      <el-form-item>
        <el-button @click="handleQuery"><Icon icon="ep:search" class="mr-5px" /> 搜索</el-button>
        <el-button @click="resetQuery"><Icon icon="ep:refresh" class="mr-5px" /> 重置</el-button>
        <el-button
          type="primary"
          plain
          @click="openForm('create')"
          v-hasPermi="['bjdx:questionnaire:create']"
        >
          <Icon icon="ep:plus" class="mr-5px" /> 新增
        </el-button>
        <el-button
          type="success"
          plain
          @click="handleExport"
          :loading="exportLoading"
          v-hasPermi="['bjdx:questionnaire:export']"
        >
          <Icon icon="ep:download" class="mr-5px" /> 导出
        </el-button>
      </el-form-item>
    </el-form>
  </ContentWrap>

  <!-- 列表 -->
  <ContentWrap>
    <el-table v-loading="loading" :data="list" :stripe="true" :show-overflow-tooltip="true">
<!--      <el-table-column label="id" align="center" prop="id" />-->
      <el-table-column label="问卷名称" align="center" prop="bqQuestionnaire" />
      <el-table-column label="问卷介绍" align="center" prop="bqDetails" >
        <template #default="scope">
          <div v-html="scope.row.bqDetails"></div>
        </template>
      </el-table-column>
      <el-table-column label="问卷排序" align="center" prop="bqOrder" />
      <el-table-column label="问卷开始指导语" align="center" prop="bqStartInfo" >
        <template #default="scope">
          <div v-html="scope.row.bqStartInfo"></div>
        </template>
      </el-table-column>
      <el-table-column label="问卷结束指导语" align="center" prop="bqEndInfo" >
        <template #default="scope">
          <div v-html="scope.row.bqStartInfo"></div>
        </template>
      </el-table-column>
<!--      <el-table-column label="问题id集" align="center" prop="bqQuestIds" />-->
      <el-table-column
        label="创建时间"
        align="center"
        prop="createTime"
        :formatter="dateFormatter"
        width="180px"
      />
      <el-table-column label="操作" align="center" min-width="120px">
        <template #default="scope">
          <el-button
            type="primary"
            link
            v-if="scope.row.tenantId == getTenantId()"
            @click="openForm('update', scope.row.id)"
            v-hasPermi="['bjdx:questionnaire:update']"
          >
            编辑
          </el-button>
          <el-button
            link
            type="danger"
            v-if="scope.row.tenantId == getTenantId()"
            @click="handleDelete(scope.row.id)"
            v-hasPermi="['bjdx:questionnaire:delete']"
          >
            删除
          </el-button>
          <el-button
            link
            type="success"
            @click="handleConfig(scope.row.id,scope.row.bqQuestionnaire,scope.row.tenantId)"
          >
            试题配置
          </el-button>
        </template>
      </el-table-column>
    </el-table>
    <!-- 分页 -->
    <Pagination
      :total="total"
      v-model:page="queryParams.pageNo"
      v-model:limit="queryParams.pageSize"
      @pagination="getList"
    />
  </ContentWrap>

  <!-- 表单弹窗：添加/修改 -->
  <QuestionnaireForm ref="formRef" @success="getList" />
</template>

<script setup lang="ts">
import { dateFormatter } from '@/utils/formatTime'
import download from '@/utils/download'
import { QuestionnaireApi, QuestionnaireVO } from '@/api/bjdx/questionnaire'
import QuestionnaireForm from './QuestionnaireForm.vue'
import { useRouter } from 'vue-router'
import { getTenantId } from '@/utils/auth'
import { ElButton } from 'element-plus'

/** 问卷 列表 */
defineOptions({ name: 'Questionnaire' })

const message = useMessage() // 消息弹窗
const { t } = useI18n() // 国际化

const loading = ref(true) // 列表的加载中
const list = ref<QuestionnaireVO[]>([]) // 列表的数据
const total = ref(0) // 列表的总页数
const queryParams = reactive({
  pageNo: 1,
  pageSize: 10,
  bqQuestionnaire: undefined,
  bqDetails: undefined,
  bqOrder: undefined,
  bqStartInfo: undefined,
  bqEndInfo: undefined,
  bqQuestIds: undefined,
  createTime: []
})
const queryFormRef = ref() // 搜索的表单
const exportLoading = ref(false) // 导出的加载中

/** 查询列表 */
const getList = async () => {
  loading.value = true
  try {
    const data = await QuestionnaireApi.getQuestionnairePage(queryParams)
    list.value = data.list
    total.value = data.total
  } finally {
    loading.value = false
  }
}

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.pageNo = 1
  getList()
}

/** 重置按钮操作 */
const resetQuery = () => {
  queryFormRef.value.resetFields()
  handleQuery()
}

/** 添加/修改操作 */
const formRef = ref()
const openForm = (type: string, id?: number) => {
  formRef.value.open(type, id)
}

/** 删除按钮操作 */
const handleDelete = async (id: number) => {
  try {
    // 删除的二次确认
    await message.delConfirm()
    // 发起删除
    await QuestionnaireApi.deleteQuestionnaire(id)
    message.success(t('common.delSuccess'))
    // 刷新列表
    await getList()
  } catch {}
}

/** 导出按钮操作 */
const handleExport = async () => {
  try {
    // 导出的二次确认
    await message.exportConfirm()
    // 发起导出
    exportLoading.value = true
    const data = await QuestionnaireApi.exportQuestionnaire(queryParams)
    download.excel(data, '问卷.xls')
  } catch {
  } finally {
    exportLoading.value = false
  }
}

/** 配置按钮操作 */
const router = useRouter()
const handleConfig = (id: number,bqQuestionnaire: string,tenantId: number) => {
  router.push({
    name: 'configQuest',
    query: { questionnaireId: id , questionnaire: bqQuestionnaire, tenantId: tenantId}
  })
}

/** 初始化 **/
onMounted(() => {
  getList()
})
</script>
